/*
 * nodes.h: Node header file
 *
 * (C) 1996,1997 Russell King
 */

#ifndef NODES_H
#define NODES_H
 
struct node
{
	struct node *next;
	int type;
	union
	{
		char *string;
		struct node *n;
		unsigned long size;
		unsigned int flags;
		unsigned int offset;
	} u;
};

#define FLAG_READONLY	1
#define FLAG_PONARGS	2
#define FLAG_RDLOAD	4
#define FLAG_RDPROMPT	8

struct compressed_node
{
	int		type;
	char		*name;
	char		*path;
	char		*passwd;
	char		*initrd_path;
	char		*args;
	int		root;
	unsigned long	ramdisk_size;
	unsigned long	flags;
	unsigned int	rdstart;
	int		file_name_offset;
	int		file_bmap_offset;
	int		file_args_offset;
	int		file_passwd_offset;
	int		file_initrd_offset;
	unsigned long	*bmap;
	unsigned long	bmap_size;
	unsigned long	*initrd;
	unsigned long	initrd_size;
	struct compressed_node *next;
};

extern struct node *config_node;
extern struct compressed_node *cnode;
extern int num_cnodes;
extern int compress_nodes (void);
extern void dump_cnodes (struct compressed_node *cnode);

#endif

